package se.kawaiiriver.nsihack;

import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Stack;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class NSIHack {
	private LinkedList filePaths; //<String>
	private LinkedList deletePaths;
	private LinkedList rmDirPaths;
	private String outPathParent;
	private String exclude;
	private String excludeNames;
	private Stack stack; // <String>
	
	private void addFilePaths() {
		stack.add(".");
		
		while (!stack.isEmpty()) {
			String current = (String)stack.pop();
			addFilePaths(current);
			
		}

	}
	private void addFilePaths(String parent) {
		File directory = new File(parent);
		File[] list = directory.listFiles();
		if (list == null) {
			System.err.println(directory + ": Expected a directory. This isn't.");
			return;
		}
		String path = parent+File.separator;
		System.out.println("SetOutPath \""+outPathParent+escape(path)+"\"");
		rmDirPaths.add(path);
		for (int i = 0; i < list.length; i++) {
			File file = list[i];
			if ((path+file.getName()).matches(exclude) || file.getName().matches(excludeNames)) {
				// empty!
			} else if (file.isFile()) {
				System.out.println("File \""+escape(path+file.getName())+"\"");
				//filePaths.add("File "+path+file.getName());
				deletePaths.add(path+file.getName());
			} else if (file.isDirectory()) {
				stack.push(path+file.getName());
			}
			
		}	
	}
	private NSIHack() {
		filePaths = new LinkedList();
		deletePaths = new LinkedList();
		rmDirPaths = new LinkedList();
		stack = new Stack();
		outPathParent = "$INSTDIR\\";
		exclude ="^.\\\\bin\\\\se.*|^.\\\\src.*|^.\\\\[.]settings$";
		excludeNames ="^iriverter-doc$|^.*[.]nsi|^setup-kawaiiriver.*$|^[.]classpath$|^[.]project$|.*[.]jardesc$|^MANIFEST[.]MF$";
		addFilePaths();
		print();
	}
	private String escape(String s) {
		return s;
	}
	private void print() {
		/*for (Iterator iter = filePaths.iterator(); iter.hasNext();) {
			String path = (String) iter.next();
			System.out.println(path);
		}*/
		for (Iterator iter = deletePaths.iterator(); iter.hasNext();) {
			String path = (String) iter.next();
			System.out.println("Delete /REBOOTOK \""+outPathParent+escape(path)+"\"");
		}
		while (!rmDirPaths.isEmpty()) {
			String path = (String) rmDirPaths.removeLast();
			System.out.println("RmDir /REBOOTOK \""+outPathParent+escape(path)+"\"");
		}
		
	}
	public static void main(String[] args) {
		new NSIHack();
	}
}
